# txtWiki Readme

## Introduction

txtWiki is an extremely basic wiki engine. It is written entirely in PHP, and uses `.txt` files to store its data, so it does not require a database, such as MySQL. The engine is approximately 9KB, all contained in a single file, and it is intended for small wikis. It requires PHP version 5.1 or higher.

## Main Features

txtWiki has a lot of features that most larger wiki engines have, like wiki syntax, page history, and password protection. There are a lot of features that will hopefully be added, but txtWiki will never be as robust as other engines, like [MediaWiki](https://www.mediawiki.org/) or [DokuWiki](https://www.dokuwiki.org/). The goal of this script was to be as small and portable as possible.

## Installation

The setup of this script could not be easier. Simply download the `index.php` file, edit the variables at the top, and create two directories where the `.txt` files to be stored.

## Variables

- `$wikititle` is obviously the title of the wiki. It appears at the top of every page and in the title bar of the browser.
- `$startpage` is the page that loads when a user initially visits the wiki.
- `$timezone` is the PHP time zone that will be used when creating new pages or editing existing ones. A complete list of PHP time zones can be found at <http://php.net/timezones/>.
- `$css` is the CSS that is loaded in the `<head>` of each page. It can either be embedded CSS, or a link to external CSS.
- `$password` is the password that is used to make changes to the wiki. Without it, users will not be able to create new pages or edit existing ones.

## Directories

The following structure is required:

- `index.php`
- `pages/`
- `pages/archive/`
- `pages/index.html (optional)`
- `pages/archive/index.html (optional)`

The `pages` directory should be located in the same place as the `index.php` file and will be where the wiki stores the `.txt` files for the most current version of each page. The `archive` folder should be located inside of the `pages` directory and will be where the wiki stores older versions of each page.

Both directories need to be created manually since the engine currently cannot create them if they do not exist. Also, both directories need to be writeable.

It is optional, but recommended, that blank `index.html` files be created inside each directory. This is the simplest way to prevent users from accessing a list of each directory's contents directly.

## Development

txtWiki is still under very active development. Suggestions, comments, and bug reports via [email](mailto:matthewdickens@me.com) are greatly appreciated.

## Credit

txtWiki was solely created by [Matthew Dickens](mailto:matthewdickens@me.com).