<?php // txtWiki v1.3

// ======================================================================
// CHANGE THESE VARIABLES TO FIT YOUR NEEDS
// ======================================================================

$wikititle = "txtWiki";
$startpage = "mainpage";
$timezone  = "America/Los_Angeles";
$css       = <<<HERE
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="http://matthewdickens.me/files/good.css">
<style>code,img{max-width:100%;}textarea{font-family:monospace;}code{background:#f5f5f5;border:1px solid #eee;padding:0 2px;min-width:100%;}hr{background:#999;border:0;height:1px;}form{margin-bottom:1em;}main,footer,header{margin:0 10%;}main:after,footer:after,header:after{content:"";clear:both;display:table;}.title{float:left;}.goto{float:right;margin-top:1.5em;}main{border:1px solid #ccc;border-width: 1px 0;}footer{font-size:.875em;}.meta{float:left;}.poweredby{float:right;text-align:right;}.searchfield,.searchbutton{display:inline;}</style>
HERE;
$password  = "letmein";

// ======================================================================
// DO NOT EDIT BELOW THIS LINE, UNLESS YOU KNOW WHAT YOU'RE DOING
// ======================================================================

header("Content-Type: text/html; charset=utf-8");
date_default_timezone_set($timezone);

if (!isset($_GET['page'])) {
  $_GET['page'] = $startpage;
}

$_GET['page'] = strtolower(preg_replace("![^a-z0-9]+!i", "-", $_GET['page']));

$file = "pages/{$_GET['page']}.txt";

$lastmodified = date("M d Y, g:i a");

echo "<!DOCTYPE html>\n"
   . "<html>\n"
   . "<head>\n"
   . "<title>{$wikititle} / {$_GET['page']}</title>\n"
   . "{$css}\n"
   . "</head>\n"
   . "<body>\n"
   . "<header>\n"
   . "<h1 class=\"title\"><a href=\"index.php\">{$wikititle}</a> / {$_GET['page']}</h1>\n"
   . "<form class=\"goto\" method=\"get\" action=\"index.php\">\n"
   . "<a href=\"index.php?page={$_GET['page']}&amp;action=listall\">List All Pages</a> - "
   . "<input type=\"text\" name=\"page\" class=\"searchfield\"> "
   . "<input type=\"submit\" value=\"Go to\" class=\"searchbutton\">\n"
   . "</form>\n"
   . "</header>\n"
   . "<main>\n";

if (!isset($_GET['action'])) {

  if (!file_exists($file)) {

    $file = "<h1>Create \"{$_GET['page']}\"?</h1>\n"
          . "<p>The page that you are looking for doesn't appear to exist. Click \"Edit\" below if you'd like to create it.</p>\n";

  } else {

    $lastmodified = date("M d Y, g:i a", filemtime($file));

    $file = "<p>" . htmlentities(file_get_contents($file)) . "</p>";

    $file = preg_replace("/(\r\n|\r)/", "\n", $file);
    $file = preg_replace("/\n/", "<br>", $file);

    $file = preg_replace("/======(.*?)======/", "</p><h1>$1</h1><p>", $file);
    $file = preg_replace("/=====(.*?)=====/", "</p><h2>$1</h2><p>", $file);
    $file = preg_replace("/====(.*?)====/", "</p><h3>$1</h3><p>", $file);
    $file = preg_replace("/===(.*?)===/", "</p><h4>$1</h4><p>", $file);

    $file = preg_replace("/\-\-\-\-/", "<hr>", $file);

    $file = preg_replace("/\[\[(.*?)\]\]/", "<a href=\"index.php?page=$1\">$1</a>", $file);
    $file = preg_replace("/\{\{(.*?)\}\}/", "<img src=\"$1\">", $file);
    $file = preg_replace("#(?<!\")https?://[0-9a-zA-Z\.\#/~\-_%=\?\&,\+\:@;!\(\)\*\$']*#i", "<a href=\"$0\">$0</a>", $file);
    $file = preg_replace("#([0-9a-zA-Z\./~\-_]+@[0-9a-z/~\-_]+\.[0-9a-z\./~\-_]+)#i", "<a href=\"mailto:$0\">$0</a>", $file);

    $file = preg_replace("/\*\*(.*?)\*\*/", "<b>$1</b>", $file);
    $file = preg_replace("/\'\'(.*?)\'\'/", "<i>$1</i>", $file);
    $file = preg_replace("/\_\_(.*?)\_\_/", "<u>$1</u>", $file);
    $file = preg_replace("/\-\-(.*?)\-\-/", "<del>$1</del>", $file);
    $file = preg_replace("/\#\#(.*?)\#\#/", "<code>$1</code>", $file);

    $file = preg_replace("/ \* (.*?)\<br\>/", "</p><li class=\"ul\">$1</li class=\"ul\"><p>", $file);
    $file = preg_replace("/\<\/p\>\<li class=\"ul\"\>/", "</p><ul><li>", $file);
    $file = preg_replace("/\<\/li class=\"ul\"\>\<p\>/", "</li></ul><p>", $file);
    $file = preg_replace("/ \# (.*?)\<br\>/", "</p><li class=\"ol\">$1</li class=\"ol\"><p>", $file);
    $file = preg_replace("/\<\/p\>\<li class=\"ol\"\>/", "</p><ol><li>", $file);
    $file = preg_replace("/\<\/li class=\"ol\"\>\<p\>/", "</li></ol><p>", $file);

    $file = preg_replace("/\<br\>\<br\>/", "</p><p>", $file);
    $file = preg_replace("/\<p\>\<\/p\>/", "", $file);
    $file = preg_replace("/\<\/ul\>\<ul\>/", "", $file);
    $file = preg_replace("/\<\/ol\>\<ol\>/", "", $file);
    $file = preg_replace("/\<p\>\<br\>/", "<p>", $file);
    $file = preg_replace("/\<br\>\<\/p\>/", "</p>", $file);

  }

  echo $file."\n";

} elseif ($_GET['action'] == 'edit') {

  if ($_SERVER['REQUEST_METHOD'] != 'POST') {

    $pageContent = (file_exists($file ) ? htmlentities(file_get_contents($file)) : NULL);

    echo "<h1>Editing \"{$_GET['page']}\"</h1>\n"
       . "<form method=\"post\">\n"
       . "<textarea name=\"content\" cols=\"80\" rows=\"20\">{$pageContent}</textarea><br>\n"
       . "<input type=\"password\" name=\"password\" placeholder=\"Password\"> "
       . "<input type=\"submit\" value=\"Save\"> or <a href=\"index.php?page={$_GET['page']}\">Cancel</a>\n</form>\n";

  } else {

    if ($_POST['password'] != $password) {
      echo "<p>The password that you entered was incorrect. Please go back and try again.</p>\n";
    } else {

      $now = date("YmdGis");
      if ($openFile = @fopen("pages/" . $_GET['page'] . ".txt", "w")) {
        @fwrite($openFile, stripslashes($_POST['content']));
      } else {
        die("Attempt to save files failed");
      }
      if ($openFile = @fopen("pages/archive/" . $_GET['page'] . "_" . $now . ".txt", "w")) {
        @fwrite($openFile, stripslashes($_POST['content']));
      }
      header("Location: index.php?page={$_GET['page']}");

    }

  }

} elseif ($_GET['action'] == 'listall') {

  echo "<h1>List of All Pages</h1>\n";

  $openDir = scandir("pages/");
  echo "<ul>\n";
  foreach ($openDir as $file) {
    if ($file != "." && $file != ".." && $file != "archive" && $file != "index.html") {
      $pageName = str_replace(".txt", "", $file);
      echo "<li><a href=\"index.php?page={$pageName}\">{$pageName}</a></li>\n";
    }
  }
  echo "</ul>\n";

} elseif ($_GET['action'] == 'history') {

  echo "<h1>Older Versions of \"{$_GET['page']}\"</h1>\n";

  $openDir = scandir("pages/archive/", 1);
  echo "<ul>\n";
  foreach ($openDir as $file) {
    if (strstr($file, '_', true) == $_GET['page']) {
      $datetime = substr(str_replace(".txt", "", strstr($file, '_')), 1);
      $year     = substr($datetime, 0, -10);
      $month    = substr($datetime, 4, -8);
      $day      = substr($datetime, 6, -6);
      $hour     = substr($datetime, 8, -4);
      $minute   = substr($datetime, 10, -2);
      $second   = substr($datetime, -2);
      echo "<li><a href=\"pages/archive/{$file}\">{$year}-{$month}-{$day} {$hour}:{$minute}:{$second}</a></li>\n";
    }
  }
  echo "</ul>\n";

}

echo "</main>\n"
   . "<footer>\n"
   . "<p class=\"meta\"><a href=\"index.php?page={$_GET['page']}&amp;action=edit\">Edit</a> - "
   . "<a href=\"index.php?page={$_GET['page']}&amp;action=history\">History</a> - "
   . "<a href=\"index.php?page={$_GET['page']}-talk\">Discuss</a><br>\n"
   . "Last modified on {$lastmodified}</p>\n"
   . "<p class=\"poweredby\">Powered by <a href=\"http://matthewdickens.me/page/txtwiki\" target=\"_blank\">txtWiki</a></p>\n"
   . "</footer>\n"
   . "</body>\n"
   . "</html>";

?>
